<script lang="ts">
import Vue from 'vue';
import { DemoModal } from '../common/index.vue';

export default Vue.extend({
  name: 'BlurbGrid',
  components: { DemoModal },
  props: {
    data: {
      type: Array,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      aiModal: {
        open: false,
      },
      ciModal: {
        open: false,
      },
      isHovering: false,
    };
  },
  methods: {
    openAIModal() {
      this.aiModal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
      // Temporary solution to put nav behind modal when modal is active
      document.querySelector('.nav-hoc').style.zIndex = '0';
    },
    closeAIModal() {
      this.aiModal.open = false;
      // Temporary solution to show nav when modal is inactive
      document.querySelector('.nav-hoc').style.zIndex = '1025';
    },
    openCIModal() {
      this.ciModal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
      // Temporary solution to put nav behind modal when modal is active
      document.querySelector('.nav-hoc').style.zIndex = '0';
    },
    closeCIModal() {
      this.ciModal.open = false;
      // Temporary solution to show nav when modal is inactive
      document.querySelector('.nav-hoc').style.zIndex = '1025';
    },
  },
});
</script>

<template>
  <div class="blurb-grid">
    <SlpContainer>
      <SlpRow class="blurb-grid-row">
        <SlpColumn v-for="item in data" :key="item.title" :col="3">
          <div class="slp-mr-md-32 blurb-grid__card">
            <SlpIcon
              v-if="item.icon?.name"
              :name="item.icon.name"
              :variant="item.icon.variant"
              :size="item.icon.size"
              class="slp-mb-8"
              slp-color="surface-700"
            />
            <SlpTypography tag="h5" variant="heading5-bold">
              {{ item.title }}</SlpTypography
            >
            <SlpTypography tag="p" variant="body2" class="slp-mt-8"
              ><span v-html="item.blurb"></span>
            </SlpTypography>
            <!-- Ai Demo -->
            <div v-if="item.list == 'ai demo'">
              <div class="modal-button" @click="openAIModal">
                <SlpButton
                  variant="secondary"
                  :data-ga-name="item.button.data_ga_name"
                  :data-ga-location="item.button.data_ga_location"
                >
                  <SlpIcon
                    class="slp-mr-8"
                    name="laptop-video"
                    variant="marketing"
                  ></SlpIcon
                  >{{ item.button.text }}
                </SlpButton>
              </div>
              <DemoModal
                v-if="item.demo"
                v-show="aiModal.open"
                :data="item.demo"
                :visible="aiModal.open"
                @close="closeAIModal"
              >
              </DemoModal>
            </div>
            <!-- ci Demo -->
            <div v-if="item.list == 'ci demo'">
              <div class="modal-button ci_button" @click="openCIModal">
                <SlpButton
                  variant="secondary"
                  :data-ga-name="item.button.data_ga_name"
                  :data-ga-location="item.button.data_ga_location"
                >
                  <SlpIcon
                    class="slp-mr-8"
                    name="laptop-video"
                    variant="marketing"
                  ></SlpIcon
                  >{{ item.button.text }}
                </SlpButton>
              </div>
              <DemoModal
                v-if="item.demo"
                v-show="ciModal.open"
                :data="item.demo"
                :visible="ciModal.open"
                @close="closeCIModal"
              >
              </DemoModal>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.blurb-grid {
  margin-top: $spacing-24;
  margin-bottom: $spacing-24;
  display: flex;
  flex-direction: row;
  align-items: center;
  @media (min-width: $breakpoint-sm) {
    margin-bottom: $spacing-96;
    margin-top: $spacing-64;
  }
  @media (min-width: $breakpoint-lg) {
    margin-bottom: $spacing-160;
  }
  &-row {
    width: 100%;
  }
  &__card {
    border: 1px solid $color-surface-200;
    border-radius: 8px;
    padding: $spacing-24;
    margin-bottom: $spacing-32;
    box-sizing: border-box;
    display: flex;
    flex-direction: column;
    height: 100%;

    @media (min-width: $breakpoint-md) {
      margin-bottom: 0;
    }

    @media (max-width: $breakpoint-md) {
      height: inherit;
    }
    .modal-button {
      margin-top: 8px;
      display: flex;
      flex-direction: row;
      align-items: end;

      button {
        font-size: 12px;
        padding: 8px 12px;
        text-align: start;
        color: $color-text-link-100;
        background: #f6f3fe;
        border: 1px solid #f6f3fe;
        border-radius: 25px;
        &:hover {
          background-color: rgba($color-surface-700, 0.1);
        }
      }
    }
    .ci_button {
      margin-top: 36px;
    }
  }
  :deep a:not(.slp-btn) {
    &:hover,
    &:focus {
      text-decoration: underline;
    }
  }
}
</style>
